package vc.thinker.thirdpartyproxy.protocolimpls.centralAir;

import vc.thinker.absctacts.protocolproxy.exceptions.MeterCodeFormatException;
import vc.thinker.thirdpartyproxy.protocolimpls.centralAir.dto.DataReportInfoDTO;

/**
 * WfIot上报数据接口定义
 *
 * @author HeTongHao
 * @since 2022/8/10 21:08
 */
public interface TerminalReportData {

    /**
     * 根据设备dto生成最终的设备id
     *
     * @param dataReportInfoDTO 设备上报信息dto
     * @return deviceId
     */
    default String lastDeviceId(DataReportInfoDTO dataReportInfoDTO) {
        return dataReportInfoDTO.getProtocolCode() + "@" + dataReportInfoDTO.getDeviceAddress();
    }

    /**
     * 根据仪表编号拆分成网关编号与deviceId
     *
     * @param meterCode 仪表编号
     * @return deviceId
     */
    default DataReportInfoDTO splitCode(String meterCode) {
        String[] split = meterCode.split("@");
        int codeItemNum = 2;
        if (split.length != codeItemNum) {
            throw new MeterCodeFormatException("CentralAir 仪表编号格式错误:" + meterCode);
        }
        return DataReportInfoDTO
                .builder()
                .protocolCode(split[0])
                .deviceAddress(split[1])
                .build();
    }

    /**
     * 终端设备上报信息
     *
     * @param dataReportInfoDTO 设备参数信息
     */
    void dataReport(DataReportInfoDTO dataReportInfoDTO);

}
